// 电机转速
Blockly.Python['d_c_generator_roll_with_speed'] = function(block) {
    var speed = block.getFieldValue('SPEED');
    var generator = block.getFieldValue('GENERATOR');
    var code;

    code = 'kq.espd(' + generator + ',' + speed + ')';
    code = code + '\n';
    return code;
};

//板载LED
Blockly.Python['turn_on_on_board_light'] = function(block) {
    var select = block.getFieldValue('SELECT');
    var colorR = block.getFieldValue('COLOR_RED');
    var colorG = block.getFieldValue('COLOR_GREEN');
    var colorB = block.getFieldValue('COLOR_BLUE');
    var code;


    code = 'kq.bld(' + select + ',' + colorG + ',' + colorR + ',' + colorB + ')';
    code = code + '\n';
    return code;
};

//　播放音调
Blockly.Python['play_sound_by_beat'] = function(block) {
    var name = block.getFieldValue('NAME');
    var beat = block.getFieldValue('BEAT');
    var code;
    let beep;
    let config = {
        C1: "262",
        D1: "294",
        E1: "330",
        F1: "349",
        G1: "392",
        A1: "440",
        B1: "494",
        C2: "523",
        D2: "587",
        E2: "659",
        F2: "698",
        G2: "784",
        A2: "880",
        B2: "988",
        C3: "1047",
        D3: "1175",
        E3: "1319",
        F3: "1397",
        G3: "1568",
        A3: "1760",
        B3: "1976"
    }
    beep = config[name];
    code = 'kq.bbp(' + beep + ',' + beat + ')';
    code = code + '\n';
    return code;
};

//表情面板显示数字
Blockly.Python['screen_show_number'] = function(block) {
    var number = Blockly.Python.valueToCode(block, 'NUMBER',
        Blockly.Python.ORDER_MULTIPLICATIVE) || '0';
    var name = block.getFieldValue('NAME');
    var code;
    code = 'kq.ebi('+ name + ',' + number +')'
    code = code + '\n';
    return code;
};

//表情面板显示时间
Blockly.Python['screen_show_time'] = function(block) {
    var name = block.getFieldValue('NAME');
    var hour = Blockly.Python.valueToCode(block, 'HOUR',
        Blockly.Python.ORDER_MULTIPLICATIVE) || '0';
    var minute = Blockly.Python.valueToCode(block, 'MINUTE',
        Blockly.Python.ORDER_MULTIPLICATIVE) || '0';
        
    var code;
    code = 'kq.ebt('+ name + ',' + hour+ ',' + minute +')'
    code = code + '\n';
    return code;
};

//表情面板绘画
Blockly.Python['screen_show_picture'] = function(block) {
    var name = block.getFieldValue('NAME');
    var number = Blockly.Python.valueToCode(block, 'NUMBER',
        Blockly.Python.ORDER_MULTIPLICATIVE) || '0';
    
    var code;
    code = 'showPicture('+ name + ',' + number +')'
    code = code + '\n';
    return code;
};

//超声波传感器距离
Blockly.Python['ultrasonic'] = function(block) {
    var name = block.getFieldValue('NAME');
    var code;
    code = 'kq.eult('+ name + ')'
    code = code + '\n';
    return code;
};

//音量传感器
Blockly.Python['volume'] = function(block) {
    var name = block.getFieldValue('NAME');
    var code;
    code = 'kq.mic('+ name + ')'

    return code;
};

//巡线传感器
Blockly.Python['line_patrol'] = function(block) {
    var name = block.getFieldValue('NAME');
    var direction = block.getFieldValue('DIRECTION');
    var color = block.getFieldValue('COLOR');
    var code;
    code = 'kq.wbl('+ name + ',' + direction + ','+ color + ')'
    code = code + '\n';
    return code;
};

//红外遥控器
Blockly.Python['telecontroller'] = function(block) {
    var name = block.getFieldValue('NAME');
    var index = block.getFieldValue('INDEX');
    let remote1 = {
        "A": "69",
        "B": "70",
        "C": "71",
        "D": "68",
        "上": "64",
        "E": "67",
        "左": "7",
        "设置": "21",
        "右": "9",
        "0": "22",
        "下": "25",
        "F": "13",
        "1": "12",
        "2": "24",
        "3": "94",
        "4": "8",
        "5": "28",
        "6": "90",
        "7": "66",
        "8": "82",
        "9": "74"
    }
    let remote2 = {
            "A": "325",
            "B": "326",
            "C": "327",
            "D": "324",
            "上": "320",
            "E": "323",
            "左": "263",
            "设置": "277",
            "右": "265",
            "0": "278",
            "下": "281",
            "F": "269",
            "1": "268",
            "2": "280",
            "3": "350",
            "4": "264",
            "5": "284",
            "6": "346",
            "7": "322",
            "8": "338",
            "9": "330"
        }
    let remote3 = {
                "A": "581",
                "B": "582",
                "C": "583",
                "D": "580",
                "上": "576",
                "E": "579",
                "左": "519",
                "设置": "533",
                "右": "521",
                "0": "534",
                "下": "537",
                "F": "525",
                "1": "524",
                "2": "536",
                "3": "606",
                "4": "520",
                "5": "540",
                "6": "602",
                "7": "578",
                "8": "594",
                "9": "586"
            }
    let remote4 = {
                    "A": "837",
                    "B": "838",
                    "C": "839",
                    "D": "836",
                    "上": "832",
                    "E": "835",
                    "左": "775",
                    "设置": "789",
                    "右": "777",
                    "0": "790",
                    "下": "793",
                    "F": "781",
                    "1": "780",
                    "2": "792",
                    "3": "862",
                    "4": "776",
                    "5": "796",
                    "6": "858",
                    "7": "834",
                    "8": "850",
                    "9": "842"
                }
    let remote5 = {
                        "A": "45",
                        "B": "46",
                        "C": "47",
                        "D": "48",
                        "上": "40",
                        "E": "43",
                        "左": "07",
                        "设置": "15",
                        "右": "09",
                        "0": "16",
                        "下": "19",
                        "F": "0D",
                        "1": "0C",
                        "2": "18",
                        "3": "5E",
                        "4": "08",
                        "5": "1C",
                        "6": "5A",
                        "7": "42",
                        "8": "52",
                        "9": "4A"
                    }
    let remote6 = {
                            "A": "45",
                            "B": "46",
                            "C": "47",
                            "D": "48",
                            "上": "40",
                            "E": "43",
                            "左": "07",
                            "设置": "15",
                            "右": "09",
                            "0": "16",
                            "下": "19",
                            "F": "0D",
                            "1": "0C",
                            "2": "18",
                            "3": "5E",
                            "4": "08",
                            "5": "1C",
                            "6": "5A",
                            "7": "42",
                            "8": "52",
                            "9": "4A"
                        }
    let remote7 = {
                            "A": "45",
                            "B": "46",
                            "C": "47",
                            "D": "48",
                            "上": "40",
                            "E": "43",
                            "左": "07",
                            "设置": "15",
                            "右": "09",
                            "0": "16",
                            "下": "19",
                            "F": "0D",
                            "1": "0C",
                            "2": "18",
                            "3": "5E",
                            "4": "08",
                            "5": "1C",
                            "6": "5A",
                            "7": "42",
                            "8": "52",
                            "9": "4A"
                        }
    let remote8 = {
                                "A": "45",
                                "B": "46",
                                "C": "47",
                                "D": "48",
                                "上": "40",
                                "E": "43",
                                "左": "07",
                                "设置": "15",
                                "右": "09",
                                "0": "16",
                                "下": "19",
                                "F": "0D",
                                "1": "0C",
                                "2": "18",
                                "3": "5E",
                                "4": "08",
                                "5": "1C",
                                "6": "5A",
                                "7": "42",
                                "8": "52",
                                "9": "4A"
                            }
    var code;

    if ( index == "1"){
        let  erc_data= remote1[name];
    }
    if ( index == "2"){
        let  erc_data= remote2[name];
    }
    if ( index == "3"){
        let  erc_data= remote3[name];
    }
    if ( index == "4"){
        let  erc_data= remote4[name];
    }
    if ( index == "5"){
        let  erc_data= remote5[name];
    }
    if ( index == "6"){
        let  erc_data= remote6[name];
    }
    if ( index == "7"){
        let  erc_data= remote7[name];
    }
    if ( index == "8"){
        let  erc_data= remote8[name];
    }
    code = 'kq.erc('+ erc_data + ')'
    return [code, Blockly.Python.ORDER_ATOMIC];
};